Create view VIS_MAA_UNASGN_SUM
as
select  c.code_desc,
	sr.status AS searchResultStatus,
  	s.user_text_1, 
	COUNT(*) AS cnt, 
	s.search_group
from search_result sr, search s, codes c, entity e, entity_type et
where s.user_text_1 is not null 
AND sr.search_id = s.search_id
AND (sr.status IS NULL 
OR sr.status in
  (SELECT act_code from app_activity_codes WHERE source_type = 'SEARCH' 
   AND act_status_code <> 'CLOSED' AND act_status_code <> 'ASSIGNED'))  
AND s.sys_expire_dt >= s.sys_create_dt 
AND sr.matched_entity_id =  e.entity_id
AND e.entity_type_id = et.entity_type_id
AND et.entity_type <> 'SEARCH' 
AND c.code_type = 'SEARCH_REASON' 
AND s.reason_code = c.code
GROUP BY  c.code_desc, sr.status, s.user_text_1, s.search_group 
union
select  c.code_desc,
	sr.status AS searchResultStatus,
  	'' as user_text_1, 
	COUNT(*) AS cnt, 
	s.search_group
from search_result sr, search s, codes c, entity e, entity_type et
where s.user_text_1 is null 
AND sr.search_id = s.search_id
AND (sr.status IS NULL 
OR sr.status in
  (SELECT act_code from app_activity_codes WHERE source_type = 'SEARCH' 
   AND act_status_code <> 'CLOSED' AND act_status_code <> 'ASSIGNED'))  
AND s.sys_expire_dt >= s.sys_create_dt 
AND sr.matched_entity_id =  e.entity_id
AND e.entity_type_id = et.entity_type_id
AND et.entity_type <> 'SEARCH' 
AND c.code_type = 'SEARCH_REASON' 
AND s.reason_code = c.code
GROUP BY  c.code_desc, sr.status, s.search_group;

create view VIS_RELATEDENTITIES as 
(
SELECT s.*
FROM 
	sep_relations s, 
	entity e, 
	entity e2, 
	entity_type et, 
	entity_type et2
WHERE 
	s.sys_delete_dt IS NULL 
	and s.relto_id = e.entity_id 
	and e.entity_type_id = et.entity_type_id
	and et.entity_type <> 'SEARCH'
	and s.entity_id = e2.entity_id 
	and e2.entity_type_id = et2.entity_type_id
	and et2.entity_type <> 'SEARCH' 
);

create view VIS_MAA_UNASGN_DET
as
SELECT
distinct search_result.*,
code_desc, 
user_text_1, 
es.like_score, 
search.search_group, 
(select  count(*) from vis_relatedentities VR where 
	(VR.entity_id = search_result.matched_entity_id OR VR.relto_id = search_result.matched_entity_id)  and 
	(VR.entity_id  in 
		( select entity_id from entity, entity_type where entity.entity_type_id = entity_type.entity_type_id 
			and entity_type.entity_type <> 'SEARCH' and VR.entity_id = entity.entity_id) 
	and
	VR.relto_id  in 
		( select entity_id from entity, entity_type where entity.entity_type_id = entity_type.entity_type_id 
			and entity_type.entity_type <> 'SEARCH' and  VR.relto_id = entity.entity_id))
) as relcount
FROM search_result, search, codes, er_entity_score es
WHERE search_result.search_id = search.search_id 
AND (codes.code_type = 'SEARCH_REASON' and search.reason_code = codes.code) 
AND search.sys_delete_dt IS NULL 
AND (search_result.status IS NULL OR search_result.status in
	 (SELECT act_code from app_activity_codes WHERE source_type = 'SEARCH' 
		AND act_status_code <> 'CLOSED' AND act_status_code <> 'ASSIGNED')) 
AND search.sys_expire_dt >= search.sys_create_dt
AND search_result.matched_entity_id in 
	( select entity_id from entity, entity_type where entity.entity_type_id = entity_type.entity_type_id 
		and entity_type.entity_type <> 'SEARCH') 
AND search_result.er_id = es.er_id 
AND (search_result.matched_entity_id = es.matched_entity_id 
	or search_result.search_entity_id = es.matched_entity_id);

Create view VIS_MAA_ASGN_DET
as 
SELECT 
search_result.*, 
code_desc,
 user_text_1, 
like_score, 
search.search_group, 
app_inbox.sys_create_us,
(select  count(*) from vis_relatedentities VR where 
	(VR.entity_id = search_result.matched_entity_id OR VR.relto_id = search_result.matched_entity_id)  and 
	(VR.entity_id  in 
		( select entity_id from entity, entity_type where entity.entity_type_id = entity_type.entity_type_id 
			and entity_type.entity_type <> 'SEARCH' and VR.entity_id = entity.entity_id) 
	and
	VR.relto_id  in 
		( select entity_id from entity, entity_type where entity.entity_type_id = entity_type.entity_type_id 
			and entity_type.entity_type <> 'SEARCH' and VR.relto_id = entity.entity_id))
) as relcount
FROM app_inbox, search_result, search, codes, er_entity_score es 
WHERE app_inbox.source_type = 'SEARCH' 
AND app_inbox.source_id = search_result.search_result_id 
AND search_result.search_id = search.search_id 
AND (code_type = 'SEARCH_REASON' and search.reason_code = codes.code)
AND search_result.status in 
	(SELECT act_code from app_activity_codes 
		WHERE source_type = 'SEARCH' AND act_status_code = 'ASSIGNED') 
AND search_result.er_id = es.er_id
AND (search_result.matched_entity_id = es.matched_entity_id or 
	search_result.search_entity_id = es.matched_entity_id);
	
	
CREATE INDEX IX_SEP_ROLES_B2 on SEP_ROLES(DSRC_ACCT_ID,ROLE_CODE_ID,DISCLOSED,SYS_DELETE_DT);
CREATE INDEX IX_PSEARCH ON SEARCH_RESULT(SEARCH_ID, MATCHED_ENTITY_ID, STATUS);
CREATE INDEX IX_USER_TEXT_1 ON SEARCH (USER_TEXT_1, SEARCH_GROUP, SEARCH_ID, SYS_DELETE_DT);
CREATE INDEX IX_GROUP ON SEARCH (SEARCH_GROUP, SEARCH_ID, USER_TEXT_1, SYS_DELETE_DT);
CREATE INDEX IX_STS_SEARCHID ON SEARCH_RESULT( STATUS,SEARCH_ID);
